﻿
$ErrorActionPreference= 'silentlycontinue'
function GenerateForm {
    ########################################################################
    # Generated On: 19.10.2017 16:32
    # Generated By: johannes
    ########################################################################

    #region Import the Assemblies
    [reflection.assembly]::loadwithpartialname("System.Drawing") | Out-Null
    [reflection.assembly]::loadwithpartialname("System.Windows.Forms") | Out-Null
    #endregion

    #region Generated Form Objects
    $form1 = New-Object System.Windows.Forms.Form
    $Abbrechen = New-Object System.Windows.Forms.Button
    $tabControl1 = New-Object System.Windows.Forms.TabControl
    $tabPage2 = New-Object System.Windows.Forms.TabPage

    $tabPage1 = New-Object System.Windows.Forms.TabPage
    $status_update = New-Object System.Windows.Forms.Label
    $status = New-Object System.Windows.Forms.Label
    $pfad = New-Object System.Windows.Forms.CheckBox
    $download_btn = New-Object System.Windows.Forms.Button

    $video_url = New-Object System.Windows.Forms.TextBox
    $video_btn = New-Object System.Windows.Forms.RadioButton
    $audio_btn = New-Object System.Windows.Forms.RadioButton
    $InitialFormWindowState = New-Object System.Windows.Forms.FormWindowState

    #----------------------------------------------
    #region Generated Form Code
    $form1.CancelButton = $Abbrechen
    $ClientSize = New-Object System.Drawing.Size
    $ClientSize.Height = 600
    $ClientSize.Width = 970
    $form1.ClientSize = $ClientSize
    $form1.DataBindings.DefaultDataSourceUpdateMode = 0
    $Min_Size = New-Object System.Drawing.Size
    $Min_Size.Height = 720
    $Min_Size.Width = 920
    $form1.MinimumSize = $Min_Size
    $form1.Name = "form1"
    $form1.StartPosition = 1
    $form1.Text = "YouTube Downloader"



    $Abbrechen_OnClick= { }

    $download_btn_OnClick= {
       #Wenn die Textbox /watch enthaltet geht das Skript weiter, sonst nicht.
       if ($video_url.text -match "/watch*") {
            [string]$format = "m4a" 
            [string]$ziel   = "Music"
            $status_update.Text = "Download (Audio) gestartet..."
            if ($video_btn.Checked) {
                $format = "mp4"
                $ziel   = "Videos"
                $status_update.Text = "Download (Video) gestartet..."
            }
            #Download startet
            .\Resource\youtube-dl.exe $video_url.text --format $format -q --no-playlist -o "C:\%HOMEPATH%\$ziel\YouTube Downloader\%(title)s-%(id)s.%(ext)s"
            #Hier wird das Download Programm gestartet, den Ausgabepfad und das Format angegeben.
            $status_update.Text = "Download abgeschlossen."
            #Falls der Download abgeschlossen wird, wird hier angezeigt, der Download wurde abgeschlossen.   
            if($pfad.checked){
                Start-Sleep -s 2
                # Code anhalten für 2 Sekunden
                $status_update.Text = "Ausgabeordner wird geöffnet"
                #Status Update Ausgabeordner wird geöffnet
                #Falls Ausgabe Ordner Öffnen ausgewählt ist, wird der Ordner mit dem Befehl untern geöffnet
                Invoke-Item "$Env:userprofile\$ziel\YouTube Downloader"
	        }
            Start-Sleep -s 3
            # Code anhalten für 3 Sekunden
            $status_update.Text = "Bereit"
            #Status wieder auf normal setzten
        } else {
            $errorText = "Bitte fügen sie einen validen Link ein."
            $status_update.Text = $errorText
            # Falls der link nicht valid ist, dann wird ein Fenster angezeigt, dass man einen validen Link einfügen soll.
            [System.Windows.Forms.MessageBox]::Show($errorText)
        }

    }



    $p = New-Object System.Drawing.Point
    $ds = New-Object System.Drawing.Size


    $p.X = 413
    $p.Y = 502
    $ds.Height = 50
    $ds.Width = 200
    $Abbrechen.DataBindings.DefaultDataSourceUpdateMode = 0
    $Abbrechen.DialogResult = 2
    $Abbrechen.Size = $ds
    $Abbrechen.Location = $p
    $Abbrechen.Name = "Abbrechen"
    $Abbrechen.Text = "Abbrechen"
    $Abbrechen.TabIndex = 1
    $Abbrechen.UseVisualStyleBackColor = $True
    $Abbrechen.add_Click($Abbrechen_OnClick)
    $form1.Controls.Add($Abbrechen)

    $p.X = 12
    $p.Y = 12
    $ds.Height = 484
    $ds.Width = 980
    $tabControl1.DataBindings.DefaultDataSourceUpdateMode = 0
    $tabControl1.Location = $p
    $tabControl1.Size = $ds
    $tabControl1.Name = "tabControl1"
    $tabControl1.SelectedIndex = 0
    $tabControl1.TabIndex = 0
    $form1.Controls.Add($tabControl1)

    $p.X = 12
    $p.Y = 12
    $ds.Height = 670
    $ds.Width = 970
    $tabPage1.DataBindings.DefaultDataSourceUpdateMode = 0
    $tabPage1.Location = $p
    $tabPage1.Size = $ds
    $tabPage1.Name = "tabPage1"
    $tabPage1.Text = "Video/Audio download"
    $tabPage1.TabIndex = 0
    $tabPage1.UseVisualStyleBackColor = $True
    $tabControl1.Controls.Add($tabPage1)

    $p.X = 50
    $p.Y = 328
    $ds.Height = 30
    $ds.Width = 600
    $status_update.DataBindings.DefaultDataSourceUpdateMode = 0
    $status_update.Location = $p
    $status_update.Name = "status_update"
    $status_update.Size = $ds
    $status_update.TabIndex = 9
    $status_update.Text = "Idle"
    $tabPage1.Controls.Add($status_update)

    $p.X = 50
    $p.Y = 400
    $ds.Height = 30
    $ds.Width = 100
    $status.DataBindings.DefaultDataSourceUpdateMode = 0
    $status.Location = $p
    $status.Name = "status"
    $status.Size = $ds
    $status.TabIndex = 8
    $status.Text = "Status:"
    $tabPage1.Controls.Add($status)

    $p.X = 50
    $p.Y = 280
    $ds.Height = 30
    $ds.Width = 500
    $pfad.DataBindings.DefaultDataSourceUpdateMode = 0
    $pfad.Location = $p
    $pfad.Name = "pfad"
    $pfad.Size = $ds
    $pfad.TabIndex = 6
    $pfad.Text = "Ausgabe Ordner öffnen"
    $pfad.UseVisualStyleBackColor = $True
    $tabPage1.Controls.Add($pfad)

    $p.X = 50
    $p.Y = 50
    $ds.Height = 60
    $ds.Width = 850
    $video_url.DataBindings.DefaultDataSourceUpdateMode = 0
    $video_url.Location = $System_Drawing_Point
    $video_url.Name = "video_url"
    $video_url.Size = $ds
    $video_url.Font = New-Object System.Drawing.Font("Arial",22,0,3,1)
    $video_url.TabIndex = 2
    $tabPage1.Controls.Add($video_url)

    $p.X = 50
    $p.Y = 70
    $ds.Height = 50
    $ds.Width = 200
    $video_btn.DataBindings.DefaultDataSourceUpdateMode = 0
    $video_btn.Location = $p
    $video_btn.Name = "video_btn"
    $video_btn.Size = $ds
    $video_btn.TabIndex = 0
    $video_btn.Text = "Video"
    $tabPage1.Controls.Add($video_btn)

    $p.X = 50
    $p.Y = 120
    $ds.Height = 50
    $ds.Width = 200
    $audio_btn.Checked = $True
    $audio_btn.Location = $p
    $audio_btn.Name = "audio_btn"
    $audio_btn.RightToLeft = 0
    $audio_btn.Size = $ds
    $audio_btn.TabIndex = 1
    $audio_btn.TabStop = $True
    $audio_btn.Text = "Audio"
    $tabPage1.Controls.Add($audio_btn)


    $p.X = 500
    $p.Y = 80
    $ds.Height = 80
    $ds.Width = 350
    $download_btn.DataBindings.DefaultDataSourceUpdateMode = 0
    $download_btn.Location = $p
    $download_btn.Name = "download_btn"
    $download_btn.Size = $ds
    $download_btn.TabIndex = 4
    $download_btn.Text = "Download"
    $download_btn.UseVisualStyleBackColor = $True
    $download_btn.add_Click($download_btn_OnClick)
    $tabPage1.Controls.Add($download_btn)

    #Save the initial state of the form
    $InitialFormWindowState = $form1.WindowState
    #Init the OnLoad event to correct the initial state of the form
    $form1.add_Load($OnLoadForm_StateCorrection)
    #Show the Form
    $form1.ShowDialog() | Out-Null

} #End Function

#Call the Function
GenerateForm
